<template>
  <div class="table-container">
      <vab-query-form-left-panel style="width:200px;">
        <el-button  icon="el-icon-delete" type="primary" @click="handleDelete">导出</el-button> 
      </vab-query-form-left-panel>
    <!-- <vab-page-header description="功能强大的数据表格组件，支持排序、分页、搜索等功能" :icon="['fas', 'table']" title="表格管理" /> -->
    <!-- <vab-query-form> -->
      <!-- <vab-query-form-left-panel style="width:200px;">
        <el-button :disabled="true" icon="el-icon-plus" type="primary" @click="handleAdd">添加</el-button>
        <el-button :disabled="true" icon="el-icon-delete" type="danger" @click="handleDelete">删除</el-button>
      </vab-query-form-left-panel> -->
        <el-row style="display: flex;align-items: center;">
  <el-col :span="12">
     <el-form ref="form" style="display: flex;align-items: center;" :inline="true" :model="queryForm" @submit.native.prevent>
       <el-form-item label="查询时间" >
            <el-date-picker
               v-model="queryForm.time"
                 unlink-panels
                value-format="yyyy-MM-dd"
               type="daterange"
               range-separator="-"
               start-placeholder="开始日期"
               end-placeholder="结束日期"
               :picker-options="pickerOptions"
            ></el-date-picker>
         </el-form-item>
           </el-form>
  </el-col>
    <el-col :span="12">
     <el-form ref="form" style="display: flex;align-items: center;" :inline="true" :model="queryForm" @submit.native.prevent>
          <el-form-item>
            <el-input v-model="queryForm.status_Inquiry" placeholder="输入手机号或用户ID" />
          </el-form-item>
          
          <el-form-item>
            <el-button icon="el-icon-search" native-type="submit" type="primary" @click="handleQuery">查询</el-button>
          </el-form-item>
           </el-form>
  </el-col>
</el-row>
      <!-- <vab-query-form-right-panel>
        <el-form ref="form" :inline="true" :model="queryForm" @submit.native.prevent>
          <el-form-item>
            <el-input v-model="queryForm.status_Inquiry" placeholder="输入手机号或用户ID" />
          </el-form-item>
          <el-form-item>
            <el-button icon="el-icon-search" native-type="submit" type="primary" @click="handleQuery">查询</el-button>
          </el-form-item>
        </el-form>
      </vab-query-form-right-panel> -->
    <!-- </vab-query-form> -->

    <el-table
      ref="tableSort"
      v-loading="listLoading"
      :data="list"
      :element-loading-text="elementLoadingText"
      :height="height"
      @selection-change="setSelectRows"
      @sort-change="tableSortChange"
    >
      <!-- <el-table-column  type="selection" width="55" /> -->
      <!-- <el-table-column label="序号"  width="95">
        <template #default="scope">
          {{ scope.$index + 1 }}
        </template>
      </el-table-column> -->
          <el-table-column align="center"  width="120" label="用户ID" prop="用户ID"/>
          <el-table-column align="center"  width="180" label="用户昵称" prop="用户昵称"/>
          <el-table-column align="center"  width="180" label="手机号" prop="手机号"/>
          <el-table-column align="center"  label="卡片名称" prop="卡片名称"/>
          <el-table-column align="center"  width="180" label="卡号" prop="卡号"/>
          <el-table-column align="center"  label="购买金额" prop="购买金额"/>
          <el-table-column align="center"  width="120" label="交易流水" prop="交易流水"/>
          <el-table-column align="center"  width="160" label="创建日期" prop="创建日期"/>
          <el-table-column align="center"  width="160" label="到期日期" prop="到期日期"/>
          <el-table-column align="center"  width="160" label="绑定时间" prop="绑定时间"/>
          <el-table-column align="center"  width="100" label="宠物ID" prop="宠物ID"/>
          <el-table-column align="center"  width="100" label="宠物名称" prop="宠物名称"/>
          <el-table-column align="center"  width="100" label="是否退会" prop="是否退会"/>
          <el-table-column align="center"  width="120" label="是否退会解绑" prop="是否退会解绑"  />
          <el-table-column align="center"  width="180" label="生效日期" prop="生效日期"/>
      <!-- <el-table-column label="头像" >
        <template #default="{ row }">
          <el-image v-if="imgShow" :preview-src-list="imageList" :src="row.img" />
        </template>
      </el-table-column> -->
      <!-- <el-table-column label="点击量" prop="pageViews"  sortable /> -->
      <!-- <el-table-column label="状态" >
        <template #default="{ row }">
          <el-tooltip class="item" :content="row.status" effect="dark" placement="top-start">
            <el-tag :type="row.status | statusFilter">
              {{ row.status }}
            </el-tag>
          </el-tooltip>
        </template>
      </el-table-column> -->
      <!-- <el-table-column label="时间" prop="datetime"  width="200" /> -->
      <!-- <el-table-column label="操作"  fixed="right" width="60px">
        <template #default="{ row }">
          <el-button v-if="row.订单状态 == '已派单' || row.订单状态 == '已支付'  " type="text" @click="handleEdit(row)">编辑</el-button>
        </template>
      </el-table-column> -->
    </el-table>
    <el-pagination
      :background="background"
      :current-page="queryForm.pageNo"
      :layout="layout"
      :page-size="queryForm.pageSize"
      :total="total"
      @current-change="handleCurrentChange"
      @size-change="handleSizeChange"
    />
    <table-edit ref="edit" />
  </div>
</template>

<script>
  import { doDelete, goodsListList,exportUserMembership } from '@/api/table'
  import TableEdit from './components/TableEdit'
  import VabPageHeader from '@/components/VabPageHeader'

  export default {
    name: 'ComprehensiveTable',
    components: {
      TableEdit,
      VabPageHeader,
    },
    filters: {
      statusFilter(status) {
        const statusMap = {
          published: 'success',
          draft: 'gray',
          deleted: 'danger',
        }
        return statusMap[status]
      },
    },
    data() {
      return {
           pickerOptions: {
          shortcuts: [{
            text: '最近一周',
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit('pick', [start, end]);
            }
          }, {
            text: '最近一个月',
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit('pick', [start, end]);
            }
          }, {
            text: '最近三个月',
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit('pick', [start, end]);
            }
          }]
        },
        imgShow: true,
        list: [],
        imageList: [],
        listLoading: true,
        layout: 'total, sizes, prev, pager, next, jumper',
        total: 0,
        background: true,
        selectRows: '',
        elementLoadingText: '正在加载...',
        queryForm: {
          pageNo: 1,
          pageSize: 20,
          title: '',
        },
        timeOutID: null,
      }
    },
    computed: {
      height() {
        return this.$baseTableHeight()
      },
    },
    created() {
      this.fetchData()
    },
    beforeDestroy() {
      clearTimeout(this.timeOutID)
    },
    mounted() {},
    methods: {
      tableSortChange() {
        const imageList = []
        this.$refs.tableSort.tableData.forEach((item, index) => {
          imageList.push(item.img)
        })
        this.imageList = imageList
      },
      setSelectRows(val) {
        this.selectRows = val
      },
      handleAdd() {
        this.$refs['edit'].showEdit()
      },
      handleEdit(row) {
        // console.log(row,'---')
        this.$refs['edit'].showEdit(row)
      },
       handleDelete() {
        exportUserMembership().then(
     response => {
     window.location.href = response.data.url;  
    // const url = window.URL.createObjectURL(new Blob([response.data])) // 创建下载链接
    // const link = document.createElement('a')
    // link.href = url
    // link.download = '全文导入模板.xlsx' // 设置文件名
    // document.body.appendChild(link)
    // link.click() // 触发下载
    // document.body.removeChild(link) // 下载后移除元素
  }
).catch(error => {
  console.error('下载失败', error)
  this.loading = false // 停止加载，隐藏加载状态
}) 
},
      // handleDelete(row) {
      //   if (row.id) {
      //     this.$baseConfirm('你确定要删除当前项吗', null, async () => {
      //       const { msg } = await doDelete({ ids: row.id })
      //       this.$baseMessage(msg, 'success')
      //       this.fetchData()
      //     })
      //   } else {
      //     if (this.selectRows.length > 0) {
      //       const ids = this.selectRows.map((item) => item.id).join()
      //       this.$baseConfirm('你确定要删除选中项吗', null, async () => {
      //         const { msg } = await doDelete({ ids: ids })
      //         this.$baseMessage(msg, 'success')
      //         this.fetchData()
      //       })
      //     } else {
      //       this.$baseMessage('未选中任何行', 'error')
      //       return false
      //     }
      //   }
      // },
      handleSizeChange(val) {
        this.queryForm.pageSize = val
        this.fetchData()
      },
      handleCurrentChange(val) {
        this.queryForm.pageNo = val
        this.fetchData()
      },
      handleQuery() {
        this.queryForm.pageNo = 1
        this.fetchData()
      },
      async fetchData() {
        this.listLoading = true
        const { data, total } = await goodsListList(this.queryForm)
        this.list = data
        const imageList = []
        data.forEach((item, index) => {
          imageList.push(item.img)
        })
        this.imageList = imageList
        this.total = total
        this.timeOutID = setTimeout(() => {
          this.listLoading = false
        }, 500)
      },
      testMessage() {
        this.$baseMessage('test1', 'success')
      },
      testALert() {
        this.$baseAlert('11')
        this.$baseAlert('11', '自定义标题', () => {
          /* 可以写回调; */
        })
        this.$baseAlert('11', null, () => {
          /* 可以写回调; */
        })
      },
      testConfirm() {
        this.$baseConfirm(
          '你确定要执行该操作?',
          null,
          () => {
            /* 可以写回调; */
          },
          () => {
            /* 可以写回调; */
          }
        )
      },
      testNotify() {
        this.$baseNotify('测试消息提示', 'test', 'success', 'bottom-right')
      },
    },
  }
</script>
